package com.FranckBarbier._Java._Railcar_control_system_client;

import processing.core.*;
import geomerative.*;

public class Control_center_client extends PApplet {

    /**
     * JNDI
     */
    private static javax.naming.Context _JNDI_context;
    /**
     * EJB
     */
    private static com.FranckBarbier._Java._Railcar_control_system.Control_center_remote _Control_center = null;
    /**
     * JMS
     */
    private static javax.jms.QueueConnectionFactory _Queue_connection_factory;
    private static javax.jms.Queue _Queue;
    private static javax.jms.QueueConnection _Queue_connection;
    private static javax.jms.QueueSession _Queue_session;
    private static javax.jms.QueueSender _Queue_sender;
    /**
     * Business
     */
    final static Terminal[] _Terminals;
    final static Milestone[] _Milestones;
    final static Railcar[] _Railcars;
    /**
     * Graphics
     */
    final static int _Window_width = 800;
    final static int _Window_heigth = 600;
    final static float _Topography_radius = _Window_width / 4;
    final static float _Topography_circumference = 2.F * PI * _Topography_radius;
    final static float _Terminal_division;
    final static float _Topography_division;
    static StringBuffer _New_destination = new StringBuffer();
    static boolean _New_destination_try = false;

    static {
        try {
            // appserv-rt.jar is required as library of this client program
            _JNDI_context = new javax.naming.InitialContext();
            _Control_center = (com.FranckBarbier._Java._Railcar_control_system.Control_center_remote) _JNDI_context.lookup("java:global/Railcar_control_system_Java_EE_6/Control_center!com.FranckBarbier._Java._Railcar_control_system.Control_center_remote");
            _Queue_connection_factory = (javax.jms.QueueConnectionFactory) _JNDI_context.lookup("jms/Control_center_queue_factory");
            _Queue = (javax.jms.Queue) _JNDI_context.lookup("jms/Control_center_queue");
            _Queue_connection = _Queue_connection_factory.createQueueConnection();
            _Queue_session = _Queue_connection.createQueueSession(false, javax.jms.Session.AUTO_ACKNOWLEDGE);
            _Queue_sender = _Queue_session.createSender(_Queue);
        } catch (javax.naming.NamingException ne) {
            System.err.println(Control_center_client.class.getName() + ne.getMessage() + ", " + ne.getExplanation());
        } catch (javax.jms.JMSException jmse) {
            System.err.println(Control_center_client.class.getName() + jmse.getMessage() + ": " + jmse.getErrorCode() + ", " + jmse.getLinkedException().getMessage());
        }

        if (_Control_center == null) {
            System.err.println("Connection failed: " + "java:global/Railcar_control_system_Java_EE_6/Control_center!com.FranckBarbier._Java._Railcar_control_system.Control_center_remote");
            System.exit(1);
        }

        int number_of_terminals = _Control_center.number_of_terminals();
        if (number_of_terminals < 2) {
            System.err.println("Invalid topography, number of terminals: " + number_of_terminals);
            System.exit(1);
        }

        int number_of_railcars = _Control_center.number_of_railcars();
        if (number_of_railcars < 1) {
            System.err.println("Invalid topography, number of railcars: " + number_of_railcars);
            System.exit(1);
        }

        _Terminals = new Terminal[number_of_terminals];
        int i = 0;
        _Terminals[i] = new Terminal(_Control_center.get_first_terminal());
        while (i < _Terminals.length - 1) {
            _Terminals[i + 1] = new Terminal(_Control_center.get_clockwise_next(_Terminals[i]._name));
            i++;
        }

        _Terminal_division = _Topography_circumference / _Terminals.length;
        _Topography_division = _Terminal_division / 10.F;

        _Milestones = new Milestone[_Terminals.length * 4];
        for (i = 0; i < _Terminals.length; i++) {
            _Milestones[i * 4] = new Milestone(Milestone._80, false, _Terminals[i]._name);
            _Milestones[i * 4 + 1] = new Milestone(Milestone._100, false, _Terminals[i]._name);
            _Milestones[i * 4 + 2] = new Milestone(Milestone._80, true, _Control_center.get_clockwise_next(_Terminals[i]._name));
            _Milestones[i * 4 + 3] = new Milestone(Milestone._100, true, _Control_center.get_clockwise_next(_Terminals[i]._name));
        }

        _Railcars = new Railcar[number_of_railcars];
        String[] railcars = _Control_center.get_railcars(new String[number_of_railcars]);
        for (i = 0; i < number_of_railcars; i++) {
            _Railcars[i] = new Railcar(railcars[i]);
        }
    }

    static boolean is_terminal_in_state(String terminal, String state) {
        return _Control_center.is_terminal_in_state(terminal, state);
    }

    static boolean terminal_destination_board_is_empty(String terminal) {
        return _Control_center.terminal_destination_board_is_empty(terminal);
    }

    static boolean get_is_clockwise(String railcar) {
        return _Control_center.get_is_clockwise(railcar);
    }

    static boolean is_railcar_in_state(String railcar, String state) {
        return _Control_center.is_railcar_in_state(railcar, state);
    }

    static boolean railcar_destination_board_is_empty(String railcar) {
        return _Control_center.railcar_destination_board_is_empty(railcar);
    }

    static void alert100(String terminal, String railcar, boolean is_clockwise) {
        try {
            _Queue_sender.send(_Queue_session.createTextMessage(com.FranckBarbier._Java._Railcar_control_system.Control_center.Alert100 + com.FranckBarbier._Java._Railcar_control_system.Control_center.Message_separator + terminal + com.FranckBarbier._Java._Railcar_control_system.Control_center.Message_separator + railcar + com.FranckBarbier._Java._Railcar_control_system.Control_center.Message_separator + (is_clockwise ? "1" : "0")));
        } catch (Exception e) {
            System.err.println(Control_center_client.class.getName() + " has sent " + com.FranckBarbier._Java._Railcar_control_system.Control_center.Alert100 + " with failure: " + e.getMessage());
        }
    }

    static void alert80(String terminal, String railcar, boolean is_clockwise) {
        try {
            _Queue_sender.send(_Queue_session.createTextMessage(com.FranckBarbier._Java._Railcar_control_system.Control_center.Alert80 + com.FranckBarbier._Java._Railcar_control_system.Control_center.Message_separator + terminal + com.FranckBarbier._Java._Railcar_control_system.Control_center.Message_separator + railcar + com.FranckBarbier._Java._Railcar_control_system.Control_center.Message_separator + (is_clockwise ? "1" : "0")));
        } catch (Exception e) {
            System.err.println(Control_center_client.class.getName() + " has sent " + com.FranckBarbier._Java._Railcar_control_system.Control_center.Alert80 + " with failure: " + e.getMessage());
        }
    }

    /**
     * There is some simulation code in the EJB module that automatically
     * activates 'terminal_crossing' and 'terminal_stopping'. So, there is no
     * need to launch these two activities from here, i.e., from the client
     * program.
     */
//    static void terminal_crossing(String terminal, String railcar, boolean is_clockwise) {
//        try {
//            _Queue_sender.send(_Queue_session.createTextMessage(com.FranckBarbier._Java._Railcar_control_system.Control_center.Terminal_crossing + com.FranckBarbier._Java._Railcar_control_system.Control_center.Message_separator + terminal + com.FranckBarbier._Java._Railcar_control_system.Control_center.Message_separator + railcar + com.FranckBarbier._Java._Railcar_control_system.Control_center.Message_separator + (is_clockwise ? "1" : "0")));
//        } catch (Exception e) {
//            System.err.println(Control_center_client.class.getName() + "\t" + Control_center.Terminal_crossing + "\t" + e.getMessage());
//        }
//    }
//
//    static void terminal_stopping(String terminal, String railcar, boolean is_clockwise) {
//        try {
//            _Queue_sender.send(_Queue_session.createTextMessage(com.FranckBarbier._Java._Railcar_control_system.Control_center.Terminal_stopping + com.FranckBarbier._Java._Railcar_control_system.Control_center.Message_separator + terminal + com.FranckBarbier._Java._Railcar_control_system.Control_center.Message_separator + railcar + com.FranckBarbier._Java._Railcar_control_system.Control_center.Message_separator + (is_clockwise ? "1" : "0")));
//        } catch (Exception e) {
//            System.err.println(Control_center_client.class.getName() + "\t" + Control_center.Terminal_stopping + "\t" + e.getMessage());
//        }
//    }
    static void railcar_new_destination(String railcar, String another_terminal) {
        com.FranckBarbier._Java._Railcar_new_destination.RailcarNewDestination_Service service = new com.FranckBarbier._Java._Railcar_new_destination.RailcarNewDestination_Service();
        com.FranckBarbier._Java._Railcar_new_destination.RailcarNewDestination port = service.getRailcarNewDestinationPort();
        port.railcarNewDestination(railcar, another_terminal);
    }

    static void terminal_new_destination(String terminal, String another_terminal) {
        com.FranckBarbier._Java._Terminal_new_destination.TerminalNewDestination_Service service = new com.FranckBarbier._Java._Terminal_new_destination.TerminalNewDestination_Service();
        com.FranckBarbier._Java._Terminal_new_destination.TerminalNewDestination port = service.getTerminalNewDestinationPort();
        port.terminalNewDestination(terminal, another_terminal);
    }
    /**
     * Graphics
     */
    private PShape _logo;
    private int _logo_X_size = 30;
    private int _logo_Y_size = 30;

    @Override
    public void setup() {
        textAlign(CENTER);
        float arc_length = 0;
        for (int i = 0; i < _Terminals.length; i++) {
            _Terminals[i].arc_length = arc_length;

            int k = 1;
            _Milestones[i * 4].arc_length = arc_length + k * _Topography_division;
            k++;
            _Milestones[i * 4 + 1].arc_length = arc_length + k * _Topography_division;
            k++;

            arc_length += _Terminal_division;

            int l = 1;
            _Milestones[i * 4 + 2].arc_length = arc_length - l * _Topography_division;
            l++;
            _Milestones[i * 4 + 3].arc_length = arc_length - l * _Topography_division;
            l++;

            for (int j = 0; j < _Railcars.length; j++) {
                if (_Terminals[i]._name.equals(_Control_center.get_origin_terminal(_Railcars[j]._name))) {
                    if (_Railcars[j]._is_clockwise) {
                        _Railcars[j].arc_length = (_Terminals[i].arc_length + k * _Topography_division);
                        k++;
                    } else {
                        _Railcars[j].arc_length = (_Terminals[i].arc_length + _Terminal_division - l * _Topography_division);
                        l++;
                    }
                }
            }
        }

        size(_Window_width, _Window_heigth);
        _logo = loadShape("resource/Railcar.svg");
        frameRate(24);

        RG.init(this);
        for (int i = 0; i < _Terminals.length; i++) {
            _Terminals[i].init_shape();
        }
        for (int i = 0; i < _Milestones.length; i++) {
            _Milestones[i].init_shape();
        }
        for (int i = 0; i < _Railcars.length; i++) {
            _Railcars[i].init_shape();
        }
    }

    @Override
    public void draw() {
        background(0);
        pushMatrix();
        translate(width / 2, height / 2);
        // shape(_logo, 0 - _logo_X_size / 2, 0 - _logo_Y_size / 2, _logo_X_size, _logo_Y_size);

        if (!_New_destination.toString().isEmpty()) {
            text(_New_destination.toString(), 15, 15);
        }
        // logo.scale(1.001F);
        popMatrix();

        for (int i = 0; i < _Terminals.length; i++) {
            _Terminals[i].draw(this);
            for (int j = 0; j < 4; j++) {
                _Milestones[i * 4 + j].draw(this);
            }
        }

        for (int i = 0; i < _Railcars.length; i++) {
            _Railcars[i].draw(this);
        }
        if (_New_destination_try) {
            String[] s = _New_destination.toString().split(" ", 2);
            assert (s.length == 2);
            int i = 0;
            while (!_New_destination.toString().isEmpty() && i < _Railcars.length) {
                if (s[0] != null && s[0].equals(_Railcars[i]._name)) {
                    int j = 0;
                    while (!_New_destination.toString().isEmpty() && j < _Terminals.length) {
                        if (s[1] != null && s[1].equals(_Terminals[j]._name)) {
                            railcar_new_destination(s[0], s[1]);
                            _New_destination.setLength(0);
                        }
                        j++;
                    }
                }
                i++;
            }
            i = 0;
            while (!_New_destination.toString().isEmpty() && i < _Terminals.length) {
                if (s[0] != null && s[0].equals(_Terminals[i]._name)) {
                    int j = 0;
                    while (!_New_destination.toString().isEmpty() && j < _Terminals.length) {
                        if (s[1] != null && s[1].equals(_Terminals[j]._name)) {
                            terminal_new_destination(s[0], s[1]);
                            _New_destination.setLength(0);
                        }
                        j++;
                    }
                }
                i++;
            }
            _New_destination_try = false;
        }
    }

    @Override
    public void keyPressed() {
        if (keyCode == java.awt.event.KeyEvent.VK_BACK_SPACE) {
            _New_destination_try = false;
            _New_destination.setLength(0);
        } else {
            if (keyCode == java.awt.event.KeyEvent.VK_ENTER) {
                _New_destination_try = true;
            } else {
                if (keyCode == 32 || (keyCode >= 65 && key <= 90) || (keyCode >= 97 || key <= 122) || (keyCode >= 48 && key <= 57)) {
                    _New_destination.append(key);
                }
            }
        }
    }

    @Override
    public void stop() {
        try {
            _Queue_connection.close(); // => _Queue_session.close(); =>  _Queue_sender.close();
            _JNDI_context.close();

        } catch (javax.jms.JMSException jmse) {
            System.err.println(Control_center_client.class.getName() + jmse.getMessage() + ": " + jmse.getErrorCode() + ", " + jmse.getLinkedException().getMessage());
        } catch (javax.naming.NamingException ne) {
            System.err.println(Control_center_client.class.getName() + ne.getMessage() + ", " + ne.getExplanation());
        }
    }

    static public void main(String[] passedArgs) {
        String[] appletArgs = new String[]{"com.FranckBarbier._Java._Railcar_control_system_client.Control_center_client"};
        if (passedArgs != null) {
            PApplet.main(concat(appletArgs, passedArgs));
        } else {
            PApplet.main(appletArgs);
        }
    }
}
