package com.FranckBarbier._Java._Railcar_control_system_client;

public class Railcar {

    /**
     * Business
     */
    String _name;
    boolean _is_clockwise;
    /**
     * Graphics
     */
    private geomerative.RShape _shape;
    float arc_length;
    private final static int _Font_size = 25;
    private final static float _Rotation_speed_when_cruising = 5.F;
    private final static float _Rotation_speed_when_waiting = 25.F;
    private final static float _Rotation_speed_when_stopped = 125.F;
    private static float _Arc_length_increment_when_cruising = Control_center_client._Topography_division / 50.F;
    private static float _Arc_length_increment_when_waiting = Control_center_client._Topography_division / 200.F;

    Railcar(String name) {
        _name = name;
        _is_clockwise = Control_center_client.get_is_clockwise(_name);
    }

    public void init_shape() {
        _shape = geomerative.RG.getText(_name, "resource/TAHOMA.TTF", _Font_size, geomerative.RG.CENTER);
    }

    public void draw(processing.core.PApplet papplet) {
        if (Control_center_client.is_railcar_in_state(_name, com.FranckBarbier._Java._Railcar_control_system.Railcar.Cruising)) {
            _shape.children[0].rotate(processing.core.PApplet.PI / _Rotation_speed_when_cruising, _shape.children[0].getCenter());
            boolean go_on = true;
            for (int i = 0; go_on && i < Control_center_client._Milestones.length; i++) {
                if (Control_center_client._Milestones[i]._name.equals(Milestone._100) && Control_center_client._Milestones[i]._is_clockwise == _is_clockwise) {
                    if (Math.abs(arc_length - Control_center_client._Milestones[i].arc_length) <= _Arc_length_increment_when_cruising) {
                        arc_length = Control_center_client._Milestones[i].arc_length;
                        go_on = false;
                        Control_center_client.alert100(Control_center_client._Milestones[i]._terminal, _name, _is_clockwise);
                    }
                }
            }
            if (go_on) {
                if (_is_clockwise) {
                    arc_length += _Arc_length_increment_when_cruising;
                } else {
                    arc_length -= _Arc_length_increment_when_cruising;
                }
            }
        }
        if (Control_center_client.is_railcar_in_state(_name, com.FranckBarbier._Java._Railcar_control_system.Railcar.Wait_for_alert80)) {
            _shape.children[0].rotate(processing.core.PApplet.PI / _Rotation_speed_when_waiting, _shape.children[0].getCenter());
            boolean go_on = true;
            for (int i = 0; go_on && i < Control_center_client._Milestones.length; i++) {
                if (Control_center_client._Milestones[i]._name.equals(Milestone._80) && Control_center_client._Milestones[i]._is_clockwise == _is_clockwise) {
                    if (Math.abs(arc_length - Control_center_client._Milestones[i].arc_length) <= _Arc_length_increment_when_waiting) {
                        arc_length = Control_center_client._Milestones[i].arc_length;
                        go_on = false;
                        Control_center_client.alert80(Control_center_client._Milestones[i]._terminal, _name, _is_clockwise);
                    }
                }
            }
            if (go_on) {
                if (_is_clockwise) {
                    arc_length += _Arc_length_increment_when_waiting;
                } else {
                    arc_length -= _Arc_length_increment_when_waiting;
                }
            }

        }
        if (Control_center_client.is_railcar_in_state(_name, com.FranckBarbier._Java._Railcar_control_system.Railcar.Wait_for_terminal_order)) {
            _shape.children[0].rotate(processing.core.PApplet.PI / _Rotation_speed_when_waiting, _shape.children[0].getCenter());
            if (_is_clockwise) {
                arc_length += _Arc_length_increment_when_waiting;
            } else {
                arc_length -= _Arc_length_increment_when_waiting;
            }
        }
//        if (Control_center_client.is_railcar_in_state(_name, com.FranckBarbier._Java._Railcar_control_system.Railcar.Stopped_on_railway) || Control_center_client.is_railcar_in_state(_name, com.FranckBarbier._Java._Railcar_control_system.Railcar.Stopped_on_railway)) {
//        }
//        if (Control_center_client.is_railcar_in_state(_name, com.FranckBarbier._Java._Railcar_control_system.Railcar.Stopped_on_railway) || Control_center_client.is_railcar_in_state(_name, com.FranckBarbier._Java._Railcar_control_system.Railcar.Stopped_at_terminal)) {
//            _shape.children[1].rotate(processing.core.PApplet.PI / _Rotation_speed_when_stopped, _shape.children[0].getCenter());
//        }
        float theta = 1.5F * processing.core.PApplet.PI + arc_length / Control_center_client._Topography_radius;
        papplet.fill(255); // White
        papplet.pushMatrix();
        papplet.translate(papplet.width / 2, papplet.height / 2);
        papplet.translate(Control_center_client._Topography_radius * papplet.cos(theta), Control_center_client._Topography_radius * papplet.sin(theta));
        _shape.draw();
        papplet.popMatrix();
    }
}